ARGS=$@
DEST_DIR="$OUTDIR/CUSTOM_DATA/adm-inspect"

if [ $MG_DEBUG == "true" ]
then
	echo "[$(date)] [$(basename "$0")] User provided arguments = [$ARGS]" >&2
fi

if [ $OC_CMD != "oc" ]
then
	echo "[$(date)] [$(basename "$0")] This script does not support [$OC_CMD]! Returning..." >&2
	exit 1
fi

if [ ${#ARGS} -eq 0 ]
then
	DEFAULT_RESOURCE_LIST="all,cm,sa,pvc"

	echo "[$(date)] [$(basename "$0")] There is no argument provided! Setting resource list to [$DEFAULT_RESOURCE_LIST]..." >&2
	ARGS="$DEFAULT_RESOURCE_LIST"
	echo "[$(date)] [$(basename "$0")] Setting 'dest-dir' to [$DEST_DIR]..."
	ARGS="$ARGS --dest-dir='$DEST_DIR'"
else
	if [[ "$ARGS" =~ "--dest-dir=" ]]	
	then
		echo "[$(date)] [$(basename "$0")] This script does not support the [--dest-dir] option, because destination directory will be set by default! Returning..." >&2
		exit 1
	else
		echo "[$(date)] [$(basename "$0")] Setting 'dest-dir' to [$DEST_DIR]..."
		ARGS="$ARGS --dest-dir='$DEST_DIR'"
	fi
fi

if [[ "$ARGS" =~ "-n " ]] || [[ "$ARGS" =~ "-A" ]] || [[ "$ARGS" =~ "--all-namespaces" ]]
then
	CMD="$OC_CMD adm inspect $ARGS"
	echo "[$(date)] [$(basename "$0")] Executing '$CMD'..."
	eval "$CMD"
else
	for NS in $(getUniqueProdNamespaces $PROD_NAMESPACES_UNIQUE_REFFILE)
	do
		CMD="$OC_CMD adm inspect $ARGS -n $NS"
		echo "[$(date)] [$(basename "$0")] Executing '$CMD'..."
		eval "$CMD"
	done
fi
