RETRY=3
ATTEMPT=0

USERNAME=$($OC_CMD get secret platform-auth-idp-credentials -n $(getProdToNamespacesMapping aimanager) --template={{.data.admin_username}} |base64 -d)
PASSWORD=$($OC_CMD get secret platform-auth-idp-credentials -n $(getProdToNamespacesMapping aimanager) --template={{.data.admin_password}} |base64 -d)
URL=$($OC_CMD get route -n $(getProdToNamespacesMapping aimanager) cp-console --no-headers | $AWK '{ print $2 }')

if [ ${#USERNAME} -eq 0 ] || [ ${#PASSWORD} -eq 0 ] || [ ${#URL} -eq 0 ]
then
	echo "[$(date)] [$(basename "$0")] USERNAME = [$USERNAME] / PASSWORD = (length) [${#PASSWORD}] / URL = [$URL] => Some or all critical parameters are empty/null!" >&2
	exit 1
fi

while [ ${#ACCESS_TOKEN} -eq 0 ] && [ $RETRY -ne 0 ]
do
	(( ATTEMPT=ATTEMPT+1 ))

	if [ ${ATTEMPT} -ne 1 ]
	then
		sleep 2
	fi

	if [ $MG_DEBUG == "true" ]
	then
		echo "[$(date)] [$(basename "$0")] [ATTEMPT #${ATTEMPT}] USERNAME = [$USERNAME] / PASSWORD = (length) [${#PASSWORD}] / URL = [$URL]" >&2
	fi

	if which jq >/dev/null
	then
		ACCESS_TOKEN=$(curl -k -X POST -H "Content-Type: application/x-www-form-urlencoded;charset=UTF-8" -d "grant_type=password&username=$USERNAME&password=$PASSWORD&scope=openid" https://$URL/idprovider/v1/auth/identitytoken --insecure -s | jq ".access_token" | sed 's/"//g')
	else
		ACCESS_TOKEN=$(curl -k -X POST -H "Content-Type: application/x-www-form-urlencoded;charset=UTF-8" -d "grant_type=password&username=$USERNAME&password=$PASSWORD&scope=openid" https://$URL/idprovider/v1/auth/identitytoken --insecure -s | sed 's/^{//; s/}$//' | tr ',' '\n' | $AWK '/^"access_token":".*"$/' | $AWK -F: '{ print $2 }' | sed 's/^"//; s/"$//')
	fi

	(( RETRY=RETRY-1 ))
done

echo "$ACCESS_TOKEN"

