OC_SUPPORTED="false"
SUPPORTED_OC_VER=(4.11 4.12 4.13 4.14 4.15)
SUPPORTED_OC_412_MINOR_VER=50
SUPPORTED_OC_413_MINOR_VER=34

OC_VER_INPUT=$($OC_CMD version | grep -E '^Server' | $AWK -F: '{ print $2 }' | sed 's/^[ ]*//')
OC_VER=${OC_VER_INPUT%.*}
OC_PATCH_VER=$(echo "$OC_VER_INPUT" | $AWK -F. '{ print $3 }')

for VER in ${SUPPORTED_OC_VER[@]}
do
	if [ $OC_VER == "$VER" ]
	then
		if [ ${#OC_PATCH_VER} -gt 0 ]
		then	
			case $OC_VER in
				4.12) 	if [ $OC_PATCH_VER -ge $SUPPORTED_OC_412_MINOR_VER ]	
						then
							OC_SUPPORTED="true"
							echo "Openshift version [$OC_VER_INPUT] is supported!"
						fi
						;;
				4.13) 	if [ $OC_PATCH_VER -ge $SUPPORTED_OC_413_MINOR_VER ]	
						then
							OC_SUPPORTED="true"
							echo "Openshift version [$OC_VER_INPUT] is supported!"
						fi
						;;
				4.14) 	OC_SUPPORTED="true"
						echo "Openshift version [$OC_VER_INPUT] is supported!"
						;;
				4.15) 	OC_SUPPORTED="true"
						echo "Openshift version [$OC_VER_INPUT] is supported!"
						;;
			esac
		fi
	fi
done

if [ $OC_SUPPORTED == "true" ]
then
	exit 0
else
	echo "[WAIOPS $PRODUCT_VERSION] Supported Openshift versions = 4.12.50 or above / 4.13.34 or above / 4.14 / 4.15"
	echo "Openshift version [$OC_VER_INPUT] is NOT supported!"
	exit 1
fi

