KAFKA_SRIMZIPODSET_REGEX="$1"

EXECPREP_HEADER="false"
DELIMITER="%%"

KAFKA_POD_NS=$(getProdToNamespacesMapping aimanager $PROD_NAMESPACES_REFFILE_FINAL)
KAFKA_STRIMZI_POD_SET=$(getResourceInstances strimzipodset "$KAFKA_SRIMZIPODSET_REGEX" $KAFKA_POD_NS)
KAFKA_POD_LIST=$($OC_CMD get strimzipodset $KAFKA_STRIMZI_POD_SET -n $KAFKA_POD_NS -o jsonpath='{.spec.pods[*].metadata.name}')

if [ $MG_DEBUG == "true" ]
then
	echo "# KAFKA_POD_LIST = [$KAFKA_POD_LIST]"
fi

for KAFKA_POD in $KAFKA_POD_LIST
do
	if isPodOk "$KAFKA_POD_NS" "$KAFKA_POD"
	then
		PVC_MOUNT_PATH_CMD="$OC_CMD get pod $KAFKA_POD -n $KAFKA_POD_NS -o jsonpath='{.spec.containers[*].volumeMounts[?(@.name==\"data\")].mountPath}'"
		PVC_MOUNT_PATH=$(eval "$PVC_MOUNT_PATH_CMD")
	
		if [ $MG_DEBUG == "true" ]
		then
			echo "# PVC_MOUNT_PATH_CMD = [$PVC_MOUNT_PATH_CMD]"
		fi
	
		if [ ${#PVC_MOUNT_PATH} -gt 0 ]
		then
			if [ $EXECPREP_HEADER == "false" ]
			then
				EXECPREP_HEADER="true"
				echo "WRITETO>/tmp/src-$$.txt:/tmp/tgt.txt"
			fi

			echo "OUT>${KAFKA_POD}${DELIMITER}${PVC_MOUNT_PATH}"
		else
			echo "# KAFKA_POD = [$KAFKA_POD] / PVC_MOUNT_PATH = [$PVC_MOUNT_PATH]"
		fi
	else
		echo "# KAFKA_POD = [$KAFKA_POD] is not running!"
	fi
done
