RESOURCE=$1
AIMGR_NAMESPACE=$2

AIMGR_INSTALL_NAME=$($OC_CMD get installations.orchestrator.aiops.ibm.com --no-headers -n $AIMGR_NAMESPACE | $AWK '{ print $1 }')

if [ ${#AIMGR_INSTALL_NAME} -eq 0 ]
then
	echo "1"
	exit 0
else
	AIMGR_INSTALL_SIZE=$($OC_CMD get installations.orchestrator.aiops.ibm.com $AIMGR_INSTALL_NAME -n $AIMGR_NAMESPACE -o=jsonpath="{.status.size}")

	if [ ${#AIMGR_INSTALL_SIZE} -eq 0 ]
	then
		echo "1"
		exit 0
	else
		if [ $AIMGR_INSTALL_SIZE != "small" ]
		then
			echo "1"
			exit 0
		fi
	fi
fi

RESOURCE_TYPE=$(echo "$RESOURCE" | $AWK -F/ '{ print $1 }')
RESOURCE_NAME=$(echo "$RESOURCE" | $AWK -F/ '{ print $2 }')

RESOURCE_READY_COUNT=$($OC_CMD get $RESOURCE_TYPE $RESOURCE_NAME -n $AIMGR_NAMESPACE --no-headers | $AWK '{ print $2 }' | $AWK -F/ '{ print $2 }')

if [ $MG_DEBUG == "true" ]
then
	echo "[$(date)] [$(basename "$0")] RESOURCE_TYPE = [$RESOURCE_TYPE] / RESOURCE_NAME = [$RESOURCE_NAME] / RESOURCE_READY_COUNT = [$RESOURCE_READY_COUNT]" >&2
fi

if [ ${#RESOURCE_READY_COUNT} -gt 0 ]
then
	if [ $RESOURCE_READY_COUNT -eq 0 ]
	then
		echo "1"	
	else
		echo "0"
	fi
else
	echo "1"
fi

